/*-
* renameFiles is a simple tool to rename many files at once
* Copyright (C) 2011 David Hobach
* tripleh [at] hackingthe [dot] net
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
-*/

#include "AbstractQObjectReader.h"

#include <QFile>

QList<QObject*> AbstractQObjectReader::readFromFile(const QString& path, QObject* parent)
{
QFile file(path);
if (!file.exists()) return QList<QObject*>();
if (!file.open(QIODevice::ReadOnly)) return QList<QObject*>(); //no text mode as with the writer

QByteArray arr = file.readAll();
file.close();
if (arr.size() == 0) return QList<QObject*>();

return this->fromBytes(arr,parent);
}
