/*-
* renameFiles is a simple tool to rename many files at once
* Copyright (C) 2011 David Hobach
* tripleh [at] hackingthe [dot] net
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
-*/

#include "ArgumentList_std.h"

using namespace std;

ArgumentList_std::ArgumentList_std(const ArgumentList_std& argumentList)
{
this->clear();
for (unsigned int i = 0; i < argumentList.size(); ++i) this->push_back(argumentList[i]);
}

bool ArgumentList_std::getSwitch(const string& option)
{
	for (unsigned int i = 0; i < this->size(); ++i)
	{
	string& cur = this->at(i);
		if (cur == option)
		{
		this->erase(this->begin() + i);
		return true;
		}
	}
return false;
}

string ArgumentList_std::getSwitchArg(const string& option, const string& defaultRetVal)
{
if (this->size() <= 1) return defaultRetVal; //necessary as this->size()-1 can become quite large if it is invalid

	for (unsigned int i = 0; i < this->size()-1; ++i) //size()-1 to always have an argument
	{
	string& cur = this->at(i);
		if (cur == option)
		{
		string ret = this->at(i+1); //always exists, see above
		this->erase(this->begin() + i+1);
		this->erase(this->begin() + i);
		return ret;
		}
	}
return defaultRetVal;
}

void ArgumentList_std::argsToStringlist(int argc, char* argv[])
{
this->clear();
for (int i = 0; i < argc; ++i) this->push_back(string(argv[i]));
}

