/*-
* renameFiles is a simple tool to rename many files at once
* Copyright (C) 2011 David Hobach
* tripleh [at] hackingthe [dot] net
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
-*/

#include <QMetaObject>
#include <QTextStream>
#include <QMetaProperty>

#include "QObjectSupport.h"

namespace QObjectSupport
{

QTextStream& operator<<(QTextStream& os, const QVariant & qv)
{
os << qv.toString();
return os;
}

QTextStream& operator<<(QTextStream& os, const QObject & qo)
{
os << qo.metaObject()->className() << "::" << qo.objectName();
return os;
}

bool operator==(const QObject& o1, const QObject& o2)
{
if (&o1 == &o2) return true;
if (o1.metaObject()->className() != o2.metaObject()->className()) return false;
const QMetaObject* meta = o1.metaObject();
	
	for (int i = 0; i < meta->propertyCount(); ++i)
	{
	QMetaProperty mp = meta->property(i);
	const char* propname = mp.name();
	if (o1.property(propname) != o2.property(propname)) return false;
	}
return true;
}

} //end namespace
