/*-
* renameFiles is a simple tool to rename many files at once
* Copyright (C) 2011 David Hobach
* tripleh [at] hackingthe [dot] net
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
-*/

#include <QTime>
#include <QStringList>

#include "QVariantHelper.h"

QString QVariantHelper::toString(const QVariant& var, const QMetaProperty& meta, bool& ok) const
{
QString result;
QVariant::Type t = meta.type();

ok = true;

	if (t == QVariant::Time)
	{
	QTime t = var.value<QTime>();
		if (t.hour() > 0)
		{
		return t.toString("hh:mm:ss");
		}
		else
		{
		return t.toString("m:ss");
		}
	}
	
	if (meta.isEnumType())
	{
	int value = var.toInt();
	QMetaEnum menum = meta.enumerator();
		if (meta.isFlagType())
		{
		QStringList selectedFlags;
		int kc = menum.keyCount();
		
			for (int j=0; j<kc; ++j) 
			{
			if (menum.value(j) == 0) continue;
			if ((value & menum.value(j)) == menum.value(j)) selectedFlags << menum.key(j);
			}
		result = selectedFlags.join("|") + QString(" (%1)").arg(value);
		}
		else result = QString("%1 (%2)").arg(menum.valueToKey(value)).arg(value);
		
	return result;
	}

	if (!var.canConvert(QVariant::String))
	{
	ok = false;
	return QString();
	}
return var.toString();
}

