/*-
* renameFiles is a simple tool to rename many files at once
* Copyright (C) 2011 David Hobach
* tripleh [at] hackingthe [dot] net
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
-*/

/** simply declares a global parent QObject pointer to use as parent for other QObjects
* it is guaranteed to be destroyed at program end!
* an alternative to the qApp macro (or QApplication::instance()), which only works, if a QApplication/QCoreApplication instance exists
*/

#ifndef GPARENT_H
#define GPARENT_H

#include <QObject>

//static: internal linking
//note that global objects are destroyed at the end of a program
static QObject PARENTOBJECT(0); //shouldn't be used
static QObject * const gParent = &PARENTOBJECT; //const pointer to PARENTOBJECT

#endif
